package net.ericaro.neobin;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import org.stringtemplate.v4.ST;
import org.stringtemplate.v4.STGroup;
import org.stringtemplate.v4.STGroupFile;

public class BinGenerator {

	public static STGroup templates = new STGroupFile("net/ericaro/neobin/neobin.stg");
	
	
	public static void compile(BinaryFormat format, File targetDirectory) throws IOException {
		
		
		generate(format, "writerUnit", targetDirectory, "BinaryWriter");
		generate(format, "interfaceUnit", targetDirectory, "BinaryReceiver");
		generate(format, "readerUnit", targetDirectory, "BinaryReader");
		
		
	}





	protected static void generate(BinaryFormat format, String template, File targetDirectory, String file) throws IOException {
		ST unit = templates.getInstanceOf(template);
		unit.add("format", format);
		String content = unit.render();
		toDir(targetDirectory, format.packageName, file+".java", content);
	}
	
	
	
	
	
	public static void toDir(File dir, String packageName, String filename, String content) throws IOException {
		File d = packageName == null ? dir : new File(dir, packageName.replace(
				'.', '/'));
		File file = new File(d, filename );
		file.getParentFile().mkdirs();
		OutputStreamWriter w = new OutputStreamWriter(
				new FileOutputStream(file));
		w.write(content);
		if (true)
			w.close();
	}
	
	
}
