package net.ericaro.neobin.types;

import org.stringtemplate.v4.ST;

import net.ericaro.neobin.BinGenerator;
import net.ericaro.neobin.BinaryType;

public class ArrayOf implements BinaryType {

	private BinaryType	sub;
	private String	reader;
	private String	writer;

	public ArrayOf(BinaryType sub) {
		this.sub = sub ;
	ST unit = BinGenerator.templates.getInstanceOf("readArrayOf");
	unit.add("type", sub);
	reader = unit.render();
	
	unit = BinGenerator.templates.getInstanceOf("writeArrayOf");
	unit.add("type", sub);
	writer = unit.render();
	
	}

	@Override
	public String getWriter() {
		return writer;
	}

	@Override
	public String getReader() {
		return reader;

	}

	@Override
	public String getJavaName() {
		return sub.getJavaName()+"[]";
	}

	@Override
	public String getJavaVar() {
		return sub.getJavaVar();
	}

	@Override
	public String getName() {
		return sub.getName()+"Array";
	}

	@Override
	public boolean isArray() {
		return true;
	}

	public BinaryType getComponent() {
		return sub;
	}

}
