package net.ericaro.neobin.types;

import net.ericaro.neobin.BinaryType;

public class DoubleType extends AbstractType implements BinaryType {

	public DoubleType(String var) {
		super(var);
	}

	@Override
	public String getWriter() {
		return "private void writeDouble(double d) throws IOException {\n" + 
				"    write8Bytes(Double.doubleToRawLongBits(d));\n" + 
				"}";
	}

	@Override
	public String getReader() {
		return "private double readDouble() throws IOException {\n" + 
				"    return Double.longBitsToDouble(read8Bytes());\n" + 
				"}";
	}

	@Override
	public String getJavaName() {
		return "double";
	}

	@Override
	public String getName() {
		return "Double";
	}
}
