package net.ericaro.neobin.types;

import net.ericaro.neobin.BinaryType;

public class FloatType extends AbstractType implements BinaryType {

	
	

	public FloatType(String var) {
		super(var);
	}

	@Override
	public String getWriter() {
		return "private void writeFloat(float f) throws IOException {\n" + 
				"    write4Bytes( Float.floatToRawIntBits(f) );\n" + 
				"}";
	}

	@Override
	public String getReader() {
		return "private float readFloat() throws IOException {\n" + 
				"    return Float.intBitsToFloat(read4Bytes());\n" + 
				"}";
	}

	@Override
	public String getJavaName() {
		return "float";
	}

	@Override
	public String getName() {
		return "Float";
	}
}
